#include "arc.h"

int fdcside;
void initmem()
{
        int c;
        ram=(unsigned long *)malloc(0x400000);
        rom=(unsigned long *)malloc(0x200000);
        for (c=0;c<0x800;c++) memstat[c]=0;
        for (c=0x400;c<0x600;c++) memstat[c]=3;
        for (c=0x400;c<0x600;c++) mempoint[c]=&ram[((c&0x7F)<<15)>>2];
        for (c=0x700;c<0x800;c++) memstat[c]=5;
        for (c=0x700;c<0x800;c++) mempoint[c]=&rom[(c&0x3F)<<13];
        memstat[0]=1;
        mempoint[0]=rom;
        for (c=0;c<0x800;c++) mempointb[c]=(unsigned char *)mempoint[c];
}

unsigned char readmemfb(unsigned long a)
{
        switch (a>>20)
        {
                case 0x32: /*IOC*/
                return readioc(a);
                case 0x33:
                switch (a)
                {
                        case 0x3310000: case 0x3310004: case 0x3310008: case 0x331000C: return read1770(a); /*1772*/
                        case 0x3350050: return 0xFF;
                        case 0x3350078: return 0xFF; /*????*/
                        case 0x33A0000: case 0x33A0004: case 0x33A0008: case 0x33A000C: return 0xFF; /*Econet*/
                        case 0x33B0000: case 0x33B0004: case 0x33B0008: case 0x33B000C: return 0xFF; /*Serial*/
                        case 0x33C0000: case 0x33C4000: case 0x33C8000: case 0x33CC000: return 0xFF; /*Expansion*/
                }
        }
        printf("Bad read byte %06X %03X %04X\n",a,a>>15,a&0x7FFF);
        dumpregs();
        exit(-1);
}

unsigned long readmemfl(unsigned long a)
{
        switch (a>>20)
        {
//#if 0
                case 0x00: case 0x01: case 0x02: case 0x03: /*RAM*/
                case 0x04: case 0x05: case 0x06: case 0x07:
                case 0x08: case 0x09: case 0x0A: case 0x0B:
                case 0x0C: case 0x0D: case 0x0E: case 0x0F:
                case 0x10: case 0x11: case 0x12: case 0x13:
                case 0x14: case 0x15: case 0x16: case 0x17:
                case 0x18: case 0x19: case 0x1A: case 0x1B:
                case 0x1C: case 0x1D: case 0x1E: case 0x1F:
                databort=1;
                return 0;
//#endif
                case 0x32: /*IOC*/
                return readioc(a);
                case 0x34: case 0x35: case 0x36: case 0x37: /*Expansion ROMs*/
                return 0xFFFFFFFF;
        }
        printf("Bad read long %06X %03X %04X\n",a,a>>15,a&0x7FFF);
        dumpregs();
        exit(-1);
}

unsigned long writememfb(unsigned long a,unsigned char v)
{
        switch (a>>20)
        {
                case 0x00: case 0x01: case 0x02: case 0x03: /*RAM*/
                case 0x04: case 0x05: case 0x06: case 0x07:
                case 0x08: case 0x09: case 0x0A: case 0x0B:
                case 0x0C: case 0x0D: case 0x0E: case 0x0F:
                case 0x10: case 0x11: case 0x12: case 0x13:
                case 0x14: case 0x15: case 0x16: case 0x17:
                case 0x18: case 0x19: case 0x1A: case 0x1B:
                case 0x1C: case 0x1D: case 0x1E: case 0x1F:
                databort=1;
                return 0;
//                case 0x1F: return; if (a>=0x1f08000 && a<=0x1f0ffff) return; break;
                case 0x32: /*IOC*/
                writeioc(a,v);
                return;
                case 0x33:
                switch (a)
                {
                        case 0x3310000: case 0x3310004: case 0x3310008: case 0x331000C: write1770(a,v); return; /*1772*/
                        case 0x3350010: return; /*Printer*/
                        case 0x3350018: /*printf("FDC latch B %02X\n",v);*/ return; /*FDC Latch B*/
                        case 0x3350040: /*printf("FDC latch A %02X\n",v);*/ fdcside=(v&0x10)?0:1;return; /*FDC Latch A*/
                        case 0x3350048: return; /*????*/
                        case 0x3350050: return; /*IOEB*/
                        case 0x3350074: return; /*????*/
                        case 0x3350078: return; /*????*/
                        case 0x33A0000: case 0x33A0004: case 0x33A0008: case 0x33A000C: return; /*Econet*/
                        case 0x33B0000: case 0x33B0004: case 0x33B0008: case 0x33B000C: return; /*Serial*/
                }
                break;
        }
        printf("Bad write byte %06X %03X %04X %08X\n",a,a>>15,a&0x7FFF,v);
        dumpregs();
        exit(-1);
}

unsigned long writememfl(unsigned long a,unsigned long v)
{
        switch (a>>20)
        {
                case 0x00: case 0x01: case 0x02: case 0x03: /*RAM*/
                case 0x04: case 0x05: case 0x06: case 0x07:
                case 0x08: case 0x09: case 0x0A: case 0x0B:
                case 0x0C: case 0x0D: case 0x0E: case 0x0F:
                case 0x10: case 0x11: case 0x12: case 0x13:
                case 0x14: case 0x15: case 0x16: case 0x17:
                case 0x18: case 0x19: case 0x1A: case 0x1B:
                case 0x1C: case 0x1D: case 0x1E: case 0x1F:
                databort=1;
                return;
                case 0x32: /*IOC*/
                writeioc(a,v>>16);
                return;
                case 0x33:
                switch (a)
                {
                        case 0x3350010: return; /*Printer*/
                }
                case 0x34: /*VIDC*/
                writevidc(v);
                return;
                case 0x36: /*MEMC*/
                writememc(a,v);
                return;
                case 0x38: case 0x39: case 0x3A: case 0x3B: /*CAM*/
                case 0x3C: case 0x3D: case 0x3E: case 0x3F:
                writecam(a);
                return;
        }
        printf("Bad write long %06X %03X %04X %08X\n",a,a>>15,a&0x7FFF,v);
        dumpregs();
        exit(-1);
}
